/////////////////////////////////////////////////////////////
//  Name    : PicLed.c                                     //
//  Compil. : CCS PCM C Compiler                           //
//  Date    : 2004-11-02                                   //
//  Version : 1.0                                          //
//  Notes   : Mruganie dioda                               //
//              PIC12F675..................................//
//                       _________                         //
//                 VCC--|         |--GND
//  Szybciej     SW2 >--|GP5      |--
//                      |         | --
//  Wolniej      SW1 >--|GP3   GP2|--->LED
//
/////////////////////////////////////////////////////////////

#include <12F675.h>
#rom 0x2007={0b11000111000100}          //bezpieczniki
#use delay(clock=4000000)               //wewnetrzny zegar ~4MHz

#byte cmcon       =  0x19
#byte ansel       =  0x9F
#byte WPU         =  0x95
#byte OPTION      =  0x81
#bit  LED         =  0x05.2            //port diody
#bit LED_TRIS     =  0x85.2
#define SW1    PIN_A3                  //port SW1
#define SW2    PIN_A5                  //port SW2

char i, j;

main()
{
  ansel=0x00;                          //Gpio jako cyfrowe
  cmcon=7;                             //komparator wylaczony
  OPTION&=0x7F;                        //wlacza podciaganie globalne
  WPU=0xff;                            //wlacza podciaganie dla GPIO

  set_rtcc(0);                           //TMR0=0
  setup_counters( RTCC_INTERNAL, RTCC_DIV_128); //TMR0 z preskalerem/128
  enable_interrupts(INT_RTCC);           //przerwamie TMR0
  enable_interrupts(GLOBAL);             //globalne przerwanie

  LED=0;                                 //wylacz led
  LED_TRIS=0;
  input(SW2);                            //port SW2 jako wejscie
  j=10;
  i=0;
  while(1)
  {
    if(!input(SW2))                    //jesli nacisniety SW2
    {
      delay_ms(10);                 //odczekaj-drgania stykow
      if(--j==255) j=0;                //zwieksz czestotliwosc migania
         while(!input(SW2));           //czekaj na zwolnienie SW2
         delay_ms(1);
    }

    if(!input(SW1))                     //jesli nacisniety SW1
    {
      delay_ms(10);                 //odczekaj-drgania stykow
      if(j++>20) j=20;              //zmniejsz czestotliwosc migania
        while(!input(SW1));           //czekaj na zwolnienie SW2
        delay_ms(1);
    }
  }
}


//Przerwanie od TMR0
#int_rtcc
void timer0()
{

  if(++i>j)
  {
    i=0;
    LED=~LED;                      //zmien stan na przeciwny
  }
}
/////////////////////////////////////////////////////////////

